#include <bits/stdc++.h>
using namespace std;

//trie

pair<int, int> trie[100005][30];

int sz = 0;

void addWord(string str){
    int n = str.size();
    int cur = 0;

    for(int i = 0; i < n; ++i){
        int c = str[i] - 'a';

        if(trie[cur][c].first != 0){
            trie[cur][c].second++;
            cur = trie[cur][c].first;
        }else{
            trie[cur][c].first = ++sz;
            trie[cur][c].second = 1;
            cur = trie[cur][c].first;
        }
    }
}

int getLess(int cur, int ind, string str){
    int n = str.size();
    if(ind == n){
        return 0;
    }

    int res = 0;
    for(int i = 0; i < (str[ind] - 'a'); ++i){
        res += trie[cur][i].second;
    }

    if(trie[cur][ind].first != 0){
        res += getLess(trie[cur][(str[ind] - 'a')].first, ind + 1, str);
    }

    return res;
}

bool exists(string str){
    int n = str.size();
    int cur = 0;

    for(int i = 0; i < n; ++i){
        int c = str[i] - 'a';

        if(trie[cur][c].first != 0){
            cur = trie[cur][c].first;
        }else{
            return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--){
        string com, str;
        cin >> com >> str;

        int n = str.size();
        for(int i = 0; i < n; ++i){
            str[i] = tolower(str[i]);
        }

        if(com == "INSERT"){
            if(!exists(str)){
                addWord(str);
            }
        }else{
            if(!exists(str)){
                cout << "NA\n";
            }else{
                int x = getLess(0, 0, str);
                cout << x << "\n";
            }
        }
    }

    return 0;
}

/*
8
INSERT aa
INSERT migg
INSERT mjgg
INSERT mkgg
LESS aa
LESS migg
LESS mjgg
LESS mkgg
*/