#include <bits/stdc++.h>
using namespace std;

pair<int, int> trie[100005][30];
int nd[100005][30];

unordered_map<string, bool> mp;

int sz = 0;

void addWord(string str){
    int n = str.size();
    int cur = 0;

    for(int i = 0; i < n; ++i){
        int c = str[i] - 'a';

        if(trie[cur][c].first != 0){
            trie[cur][c].second++;
            if(i == n - 1){
                nd[cur][c]++;
            }
        }else{
            trie[cur][c].first = ++sz;
            trie[cur][c].second = 1;
            if(i == n - 1){
                nd[cur][c]++;
            }
        }

        cur = trie[cur][c].first;
    }
}

int getLess(int cur, int ind, string str){
    int n = str.size();
    if(ind == n){
        return 0;
    }

    int c = str[ind] - 'a';

    int res = 0;
    for(int i = 0; i < c; ++i){
        res += trie[cur][i].second;
    }

    res += nd[cur][c]; ///add all that ends here
    res += getLess(trie[cur][c].first, ind + 1, str); ///next character

    return res;
}

bool exists(string str){
    int n = str.size();
    int cur = 0;

    for(int i = 0; i < n; ++i){
        int c = str[i] - 'a';

        if(trie[cur][c].first != 0){
            cur = trie[cur][c].first;
        }else{
            return false;
        }
    }

    return true;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int t;
    cin >> t;
    while(t--){
        string com, str;
        cin >> com >> str;

        int n = str.size();
        for(int i = 0; i < n; ++i){
            str[i] = tolower(str[i]);
        }

        if(com == "INSERT"){
            if(!mp[str]){
                addWord(str);
                mp[str] = true;
            }
        }else{
            if(!mp[str]){
                cout << "NA\n";
            }else{
                int x = getLess(0, 0, str) - 1;///this returns <=, so -1
                cout << x << "\n";
            }
        }
    }

    return 0;
}

/*
10

INSERT aa
INSERT migg
INSERT mjgg
INSERT mkgg
LESS aa
LESS migg
LESS mjgg
INSERT mjgz
LESS mkgg
LESS mjgz


4
INSERT a
INSERT aa
INSERT aaa
LESS aa
*/